/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : TSS1.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : TSS_Library
**     Version     : Component 02.001, Driver 01.00, CPU db: 3.00.000
**     Compiler    : Keil ARM C/C++ Compiler
**     Date/Time   : 2012-09-21, 12:21, # CodeGen: 11
**     Contents    :
**         Configure - byte TSS1_Configure(void);
**
**     (c) Copyright Freescale Semiconductor, Inc. 2010
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE TSS1. */

#include "Events.h"
#include "TSS1.h"

/*
** ===================================================================
**     Function    :  TSS1_InitDevices
**     Description :
**         The function is intended for implementation of peripherals
**         initialization. TSS Component automatically enables clock
**         for all used TSS peripherals, setup pin multiplexors,
**         installs RTOS interrupt service routines etc.
**         This function is generated always and depends on user if
**         it is used.
**         This function is automatically called during the
**         TSS1_fOnInit callback execution.
**     Parameters  : None
**     Returns     : None
** ===================================================================
*/

void TSS1_InitDevices(void)
{
  /* RTOS interrupt vectors installation */

  /* {MQXLite RTOS Adapter} Set new interrupt vector (function handler and ISR parameter) */
  (void)_int_install_isr(LDD_ivIndex_INT_TSI0, TSS_TSI0Isr, NULL);

  /* Modules Clock support */

  /* SIM_SCGC5: PORTB=1 */
  SIM_SCGC5 |= SIM_SCGC5_PORTB_MASK;                                                   
  /* SIM_SCGC5: TSI=1 */
  SIM_SCGC5 |= SIM_SCGC5_TSI_MASK;                                                   

  /* TSI Module MUX Settings */

  PORTB_PCR16 = PORT_PCR_MUX(0);
  PORTB_PCR17 = PORT_PCR_MUX(0);
}

/*
** ===================================================================
**     Method      :  TSS1_Configure (component TSS_Library)
**
**     This method can be used also under name "Configure"
**
**     Description :
**         Whole TSS initialization and configuration of registers.
**         Contains main TSS_Init() function, TSS System Config
**         registers and all Control Config registers initialization
**         according to setting of Component properties. The user have
**         to place this function into the proper location in the
**         source code.
**     Parameters  : None
**     Returns     :
**         ---             - Error status code of Configure method. If
**                           the configuration is successful the
**                           TSS_STATUS_OK is reported, otherwise is
**                           reported one of error status codes
**                           described in TSSAPIRM document.
** ===================================================================
*/
byte TSS1_Configure(void)
{
  byte u8Result = TSS_STATUS_OK;

  /* Main TSS Initialization */
  (void) TSS_Init();

  /* Configure the Analog Slider Control to report the touch and release events */
  u8Result |= TSS_SetASliderConfig(AnalogSlider.ControlId, ASlider_Events_Register, TSS_ASLIDER_MOVEMENT_EVENT_EN_MASK | TSS_ASLIDER_INITIAL_TOUCH_EVENT_EN_MASK);
  /* Configure the Analog Slider Auto-Repeat Rate Register */
  u8Result |= TSS_SetASliderConfig(AnalogSlider.ControlId, ASlider_AutoRepeatRate_Register, 0x00);
  /* Configure the Analog Slider Movement Timeout Register */
  u8Result |= TSS_SetASliderConfig(AnalogSlider.ControlId, ASlider_MovementTimeout_Register, 0x02);
  /* Configure the Analog Slider Range Register */
  u8Result |= TSS_SetASliderConfig(AnalogSlider.ControlId, ASlider_Range_Register, 0x20);
  /* Configure ASlider Control configuration registers */
  u8Result |= TSS_SetASliderConfig(AnalogSlider.ControlId, ASlider_ControlConfig_Register, TSS_ASLIDER_CONTROL_EN_MASK | TSS_ASLIDER_CALLBACK_EN_MASK | 0x00);

  /* Enables all electrodes */
  u8Result |= TSS_SetSystemConfig(System_ElectrodeEnablers_Register+0, 0x03);
  /* Sets Trigger Mode */
  u8Result |= TSS_SetSystemConfig(System_SystemTrigger_Register, TSS_TRIGGER_MODE_ALWAYS);
  /* Sets the Number of samples for all electrodes */
  u8Result |= TSS_SetSystemConfig(System_NSamples_Register, 0x08);
  /* Configures the DC Tracker value */
  u8Result |= TSS_SetSystemConfig(System_DCTrackerRate_Register, 0x64);
  /* Configures the Response Time */
  u8Result |= TSS_SetSystemConfig(System_ResponseTime_Register, 0x04);
  /* Configures the Stuck-key Timeout */
  u8Result |= TSS_SetSystemConfig(System_StuckKeyTimeout_Register, 0x00);
  /* Configures System SystemConfig Register */
  u8Result |= TSS_SetSystemConfig(System_SystemConfig_Register, TSS_SYSTEM_EN_MASK);

  return u8Result;
}

/* END TSS1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
