/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DMA1.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : DMA_LDD
**     Version     : Component 01.061, Driver 01.07, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-10-01, 10:16, # CodeGen: 4
**     Abstract    :
**          This embedded component implements initialization
**          and runtime handling of an on-chip DMA controller.
**     Settings    :
**          Component name                                 : DMA1
**          Device                                         : DMA
**          Channel arbitration type                       : Round robin
**          DMA channels                                   : 3
**            Settings of DMA channel                      : DMA_Channel0
**              Channel                                    : DMA_Channel0
**              Channel arbitration type                   : Round robin
**              Interrupt service                          : Enabled
**                Transfer complete interrupt              : INT_DMA0
**                Transfer complete interrupt priority     : medium priority
**            Settings of DMA channel                      : DMA_Channel1
**              Channel                                    : DMA_Channel1
**              Channel arbitration type                   : Round robin
**              Interrupt service                          : Enabled
**                Transfer complete interrupt              : INT_DMA1
**                Transfer complete interrupt priority     : medium priority
**            Settings of DMA channel                      : DMA_Channel2
**              Channel                                    : DMA_Channel2
**              Channel arbitration type                   : Round robin
**              Interrupt service                          : Disabled
**          Initialization                                 : 
**            Enabled in init. code                        : yes
**            Auto initialization                          : yes
**          CPU clock/configuration selection              : 
**            Clock configuration 0                        : This component enabled
**            Clock configuration 1                        : This component disabled
**            Clock configuration 2                        : This component disabled
**     Contents    :
**         Init                         - LDD_TDeviceData* DMA1_Init(LDD_TUserData *UserDataPtr);
**         Deinit                       - void DMA1_Deinit(LDD_TDeviceData *DeviceDataPtr);
**         Enable                       - LDD_TError DMA1_Enable(LDD_TDeviceData *DeviceDataPtr);
**         Disable                      - LDD_TError DMA1_Disable(LDD_TDeviceData *DeviceDataPtr);
**         AllocateChannel              - LDD_TError DMA1_AllocateChannel(LDD_TDeviceData *DeviceDataPtr,...
**         EnableChannel                - LDD_TError DMA1_EnableChannel(LDD_TDeviceData *DeviceDataPtr,...
**         DisableChannel               - LDD_TError DMA1_DisableChannel(LDD_TDeviceData *DeviceDataPtr,...
**         StartChannelTransfer         - LDD_TError DMA1_StartChannelTransfer(LDD_TDeviceData *DeviceDataPtr,...
**         CancelChannelTransfer        - LDD_TError DMA1_CancelChannelTransfer(LDD_TDeviceData *DeviceDataPtr,...
**         GetChannelStatus             - LDD_DMA_TChannelStatus DMA1_GetChannelStatus(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelSourceAddress      - LDD_TError DMA1_SetChannelSourceAddress(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelDestinationAddress - LDD_TError DMA1_SetChannelDestinationAddress(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelByteCount          - LDD_TError DMA1_SetChannelByteCount(LDD_TDeviceData *DeviceDataPtr,...
**         GetChannelDescriptorUpdate   - LDD_TError DMA1_GetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelDescriptorUpdate   - LDD_TError DMA1_SetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __DMA1_H
#define __DMA1_H

/* MODULE DMA1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "Cpu.h"
#include "DMA_PDD.h"
#include "DMAMUX_PDD.h"
#include "PE_LDD.h"

#include "Cpu.h"


/* Peripheral base address of a device allocated by the component. This constant can be used directly in PDD macros. */
#define DMA1_PRPH_BASE_ADDRESS  0x40008000U
  
/* Device data structure pointer used when auto initialization property is enabled. This constant can be passed as a first parameter to all component's methods. */
#define DMA1_DeviceData  ((LDD_TDeviceData *)PE_LDD_GetDeviceStructure(PE_LDD_COMPONENT_DMA1_ID))

/* Methods configuration constants - generated for all enabled component's methods */
#define DMA1_Init_METHOD_ENABLED
#define DMA1_Deinit_METHOD_ENABLED
#define DMA1_Enable_METHOD_ENABLED
#define DMA1_Disable_METHOD_ENABLED
#define DMA1_AllocateChannel_METHOD_ENABLED
#define DMA1_EnableChannel_METHOD_ENABLED
#define DMA1_DisableChannel_METHOD_ENABLED
#define DMA1_StartChannelTransfer_METHOD_ENABLED
#define DMA1_CancelChannelTransfer_METHOD_ENABLED
#define DMA1_GetChannelStatus_METHOD_ENABLED
#define DMA1_SetChannelSourceAddress_METHOD_ENABLED
#define DMA1_SetChannelDestinationAddress_METHOD_ENABLED
#define DMA1_SetChannelByteCount_METHOD_ENABLED
#define DMA1_GetChannelDescriptorUpdate_METHOD_ENABLED
#define DMA1_SetChannelDescriptorUpdate_METHOD_ENABLED

/* Number of DMA channels supported by hardware */
#define DMA1_DMA_CHANNELS_NUMBER 0x04U
/* DMA doesn't support multiple multiplexers */
#define DMA1_DMAMUX0_CHANNELS_NUMBER 0x00U
#define DMA1_DMAMUX1_CHANNELS_NUMBER 0x00U
/* Number of configured channels (i.e. all channels set in DMA1 component) */
#define DMA1_CONFIGURED_CHANNELS_NUMBER 0x03U
/* Number of available channels (i.e. all configured channels excluding permanently allocated channels) */
#define DMA1_AVAILABLE_CHANNELS_NUMBER 0x00U
/* No DMAMUX0 channels configured */
#define DMA1_CONFIGURED_DMAMUX0_CHANNELS_NUMBER 0x00U
/* No DMAMUX0 channels available */
#define DMA1_AVAILABLE_DMAMUX0_CHANNELS_NUMBER 0x00U
/* No DMAMUX1 channels configured */
#define DMA1_CONFIGURED_DMAMUX1_CHANNELS_NUMBER 0x00U
/* No DMAMUX1 channels available */
#define DMA1_AVAILABLE_DMAMUX1_CHANNELS_NUMBER 0x00U
/* Number of permanently allocated channels */
#define DMA1_ALLOCATED_CHANNELS_NUMBER 0x03U
/* No DMAMUX0 permanently allocated channels */
#define DMA1_ALLOCATED_DMAMUX0_CHANNELS_NUMBER 0x00U
/* No DMAMUX1 permanently allocated channels */
#define DMA1_ALLOCATED_DMAMUX1_CHANNELS_NUMBER 0x00U
/* Number of available channels capable of periodic triggering (excluding permanently allocated channels) */
#define DMA1_PERIODIC_TRIGGER_CHANNELS_NUMBER 0x00U
/* No DMAMUX0 channels capable of periodic triggering available. */
#define DMA1_PERIODIC_TRIGGER_DMAMUX0_CHANNELS_NUMBER 0U
/* No DMAMUX1 channels capable of periodic triggering available. */
#define DMA1_PERIODIC_TRIGGER_DMAMUX1_CHANNELS_NUMBER 0U
/* No channels without periodic triggering capability available. */
#define DMA1_SIMPLE_CHANNELS_NUMBER 0U
/* No DMAMUX0 channels without periodic triggering capability available. */
#define DMA1_SIMPLE_DMAMUX0_CHANNELS_NUMBER 0U
/* No DMAMUX1 channels without periodic triggering capability available. */
#define DMA1_SIMPLE_DMAMUX1_CHANNELS_NUMBER 0U
/* Channel number constants */
#define DMA1_CHANNEL_0 0x00U
#define DMA1_CHANNEL_1 0x01U
#define DMA1_CHANNEL_2 0x02U
#define DMA1_CHANNEL_3 0x03U
/*  This constant contains mask of all supported events */
#define DMA1_AVAILABLE_EVENTS_MASK (LDD_DMA_ON_COMPLETE | LDD_DMA_ON_ERROR)
typedef struct {
  LDD_DMA_TChannelNumber ChannelNumber; /* ChannelNumber */
  LDD_DMA_TTransferDescriptor *DescriptorPtr; /* Pointer to the channel's transfer descriptor */
  bool Interrupts;                     /* True, if the DMA channel has enabled interrupts */
  bool Initialized;                    /* True, if the DMA channel has been initialized */
  bool Enabled;                        /* True, if the DMA channel is enabled */
} DMA1_TDescriptorRecord;              /* Transfer descriptor record type. */

typedef DMA1_TDescriptorRecord *DMA1_TDescriptorRecordPtr; /* Pointer to transfer descriptor record. */

typedef struct {
  bool EnUser;                         /* Enable/Disable device */
  DMA1_TDescriptorRecord DescriptorRecord[DMA1_CONFIGURED_CHANNELS_NUMBER]; /* Transfer descriptor records table, one record per one channel. */
  DMA1_TDescriptorRecord *ChannelRecord[DMA1_DMA_CHANNELS_NUMBER]; /* Channel record table for each channel. */
  LDD_TUserData *UserDataPtr;          /* User device data structure */
  LDD_TEventMask EventMask[DMA1_DMA_CHANNELS_NUMBER]; /* Event mask of enabled events */
} DMA1_TDeviceData;                    /* Device data structure */

/* DMA Transfer descriptor structure variables external declarations */
extern DMA1_TDeviceData *DMA1_DeviceDataPtr;


LDD_TDeviceData* DMA1_Init(LDD_TUserData *UserDataPtr);
/*
** ===================================================================
**     Method      :  DMA1_Init (component DMA_LDD)
**
**     Description :
**         Initializes the device according to design-time
**         configuration properties. Allocates memory for the device
**         data structure. 
**         If the <Enable in init. code> is set to "yes" then the
**         device is also enabled (see the description of the Enable
**         method).
**         This method can be called only once. Before the second call
**         of Init the Deinit method must be called first.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     Returns     :
**         ---             - Pointer to the device data structure. 
** ===================================================================
*/

void DMA1_Deinit(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  DMA1_Deinit (component DMA_LDD)
**
**     Description :
**         Deinitializes the associated peripheral(s) and frees the
**         component internal data structure.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

LDD_TError DMA1_Enable(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  DMA1_Enable (component DMA_LDD)
**
**     Description :
**         Enables DMA device.
**         This method is intended to be used together with Disable
**         method to temporary switch On/Off the device after the
**         device is initialized.
**         This method is required if the <Enable in init. code>
**         property is set to "no" value.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
** ===================================================================
*/

LDD_TError DMA1_Disable(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  DMA1_Disable (component DMA_LDD)
**
**     Description :
**         Disables the DMA device. When the device is disabled, some
**         component methods should not be called. If so, error
**         ERR_DISABLED is reported.
**         This method is intended to be used together with Enable
**         method to temporary switch On/Off the device after the
**         device is initialized.
**         This method is not required. The Deinit method can be used
**         to switch off and uninstall the device.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
** ===================================================================
*/

LDD_TError DMA1_AllocateChannel(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_AllocateChannel (component DMA_LDD)
**
**     Description :
**         The method allocates DMA channel for the DMA transfer
**         defined by the transfer descriptor input parameter
**         DescriptorPtr. This method must be called before DMA channel
**         is initialized. Otherwise ERR_NOTAVAIL error code is
**         returned after call of DMA_LDD channel methods.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any possible
**                           channel with desired features to be
**                           allocated.
** ===================================================================
*/

LDD_TError DMA1_EnableChannel(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_EnableChannel (component DMA_LDD)
**
**     Description :
**         The method initializes and/or enables the DMA channel
**         allocated for the DMA transfer defined by the transfer
**         descriptor input parameter DescriptorPtr. First call of this
**         method on given DMA channel initializes it and enables HW
**         requests if Peripheral device or Always enabled trigger
**         source is selected in transfer descriptor Trigger source
**         type item. This method can be also used together with
**         Disable method to temporary switch On/Off the DMA channel HW
**         requests. In such case DMA channel registers are not
**         reinitialized again. New initialization of DMA channel can
**         be done via SetChannelDescriptorUpdate method which
**         reinitializes whole channel with new transfer descriptor.
**         After calling of EnableChannel method channel status is set
**         to LDD_DMA_IDLE.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Transfer descriptor data
**                           are inconsistent.
** ===================================================================
*/

LDD_TError DMA1_DisableChannel(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_DisableChannel (component DMA_LDD)
**
**     Description :
**         The method disables the DMA channel allocated for the DMA
**         transfer defined by the transfer descriptor input parameter
**         DescriptorPtr and disables HW requests services. However, it
**         is still possible to start transfer explicitly as SW
**         transfer requests via StartChannelTransfer method. After
**         calling of DisableChannel method channel status is set to
**         LDD_DMA_IDLE.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/

LDD_TError DMA1_StartChannelTransfer(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_StartChannelTransfer (component DMA_LDD)
**
**     Description :
**         The method starts DMA transfer on the allocated DMA channel
**         defined by the transfer descriptor input parameter
**         DescriptorPtr. This methods initiates explicit SW transfer
**         request and can be called after channel is initialized by
**         first calling of EnableChannel method. Explicit SW transfer
**         request is serviced regardless of disabling HW requests
**         after calling of the DisableChannel method.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/

LDD_TError DMA1_CancelChannelTransfer(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_CancelChannelTransfer (component DMA_LDD)
**
**     Description :
**         The method cancels DMA transfer on channel specified by the
**         transfer descriptor input parameter DescriptorPtr. The
**         cancel takes effect after the last write of the current
**         read/write sequence and the channel retires as if the
**         request was serviced normally.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/

LDD_DMA_TChannelStatus DMA1_GetChannelStatus(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_GetChannelStatus (component DMA_LDD)
**
**     Description :
**         The method gets a status of the DMA channel allocated for
**         the DMA transfer defined by the transfer descriptor input
**         parameter DescriptorPtr. This method is intended to perform
**         fast check of DMA channel transfer status and no validity or
**         consistency checks are performed. Possible values are
**         LDD_DMA_IDLE returned after enabling or disabling channel or
**         between separate transfers of nested transfer operation.
**         During the DMA transfer active operation LDD_DMA_BUSY is
**         returned. LDD_DMA_DONE is returned after cycle-steal, single
**         or nested transfer completes and before start of another
**         transfer or before channel enable or disable. If DMA error
**         was detected, LDD_DMA_ERR is returned.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - DMA channel status.
** ===================================================================
*/

LDD_TError DMA1_SetChannelSourceAddress(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TAddress Address);
/*
** ===================================================================
**     Method      :  DMA1_SetChannelSourceAddress (component DMA_LDD)
**
**     Description :
**         The method sets an source address for data to be transferred
**         by the DMA channel allocated for the DMA transfer defined by
**         the transfer descriptor parameter DescriptorPtr. This method
**         can be used to update DMA transfer source address when DMA
**         channel is enabled. New source address is stored in transfer
**         descriptor and written to associated DMA channel registers.
**         The new source address can be optionally checked for
**         consistency with rest of the transfer descriptor data.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**         Address         - Address of source data for a DMA
**                           channel allocated for a DMA transfer
**                           descriptor defined by the TCD parameter.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected source address
**                           is inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/

LDD_TError DMA1_SetChannelDestinationAddress(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TAddress Address);
/*
** ===================================================================
**     Method      :  DMA1_SetChannelDestinationAddress (component DMA_LDD)
**
**     Description :
**         The method sets an destination address for data to be
**         transferred by the DMA channel allocated for the DMA
**         transfer defined by the transfer descriptor parameter
**         DescriptorPtr. This method can be used to update DMA
**         transfer destination address when DMA channel is enabled.
**         New destination address is stored in transfer descriptor and
**         written to associated DMA channel registers. The new source
**         address can be optionally checked for consistency with rest
**         of the transfer descriptor data.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**         Address         - Address of a destination data to
**                           be transferred to by the DMA channel
**                           allocated for a DMA transfer descriptor
**                           defined by the TCD parameter.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected source address
**                           is inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/

LDD_TError DMA1_SetChannelByteCount(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TByteCount ByteCount);
/*
** ===================================================================
**     Method      :  DMA1_SetChannelByteCount (component DMA_LDD)
**
**     Description :
**         The method sets a byte count (size of data) to be
**         transferred by the DMA channel allocated for the DMA
**         transfer defined by the transfer descriptor input parameter
**         DescriptorPtr. This method can be used to update DMA
**         transfer byte count when DMA channel is enabled. New
**         transfer byte count is stored in transfer descriptor and
**         written to associated DMA channel registers. The new
**         transfer byte count can be optionally checked for
**         consistency with rest of the transfer descriptor data. If
**         nested operation is used, the method sets the minor (inner)
**         loop byte count.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**         ByteCount       - Byte count (size of data) to
**                           be transferred by the DMA channel allocated
**                           for a DMA transfer descriptor defined by
**                           the TCD parameter.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected byte count is
**                           inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/

LDD_TError DMA1_GetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_GetChannelDescriptorUpdate (component DMA_LDD)
**
**     Description :
**         The method gets transfer descriptor parameters of the DMA
**         channel allocated for the component. Allocated channel is
**         identified by the transfer descriptor structure address and
**         it is updated with values from the allocated DMA channel
**         registers. The method can be called only if the channel is
**         disabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor or allocated channel is enabled.
** ===================================================================
*/

LDD_TError DMA1_SetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr);
/*
** ===================================================================
**     Method      :  DMA1_SetChannelDescriptorUpdate (component DMA_LDD)
**
**     Description :
**         The method updates DMA channel allocated by transfer
**         descriptor defined by DescriptorPtr. Allocated DMA channel
**         registers are reinitialized with new values from transfer
**         descriptor structure. New tansfer descriptor is tested for
**         data consistency. The method can be called only if the
**         channel is disabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor or allocated channel is enabled.
**                           - ERR_PARAM_DATA - Selected transfer
**                           descriptor is inconsistent.
** ===================================================================
*/

void DMA1_SetClockConfiguration(LDD_TDeviceData *DeviceDataPtr, LDD_TClockConfiguration ClockConfiguration);
/*
** ===================================================================
**     Method      :  DMA1_SetClockConfiguration (component DMA_LDD)
**
**     Description :
**         This method changes the clock configuration. During a clock 
**         configuration change the component changes it's setting 
**         immediately upon a request.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

/* {Default RTOS Adapter} ISR function prototype */
PE_ISR(DMA1_Channel0Interrupt);

/* {Default RTOS Adapter} ISR function prototype */
PE_ISR(DMA1_Channel1Interrupt);


/* END DMA1. */

#endif
/* ifndef __DMA1_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
