/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DMAT_UART_OUT.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : DMATransfer_LDD
**     Version     : Component 01.099, Driver 01.07, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-10-01, 10:22, # CodeGen: 5
**     Abstract    :
**          This embedded component implements
**          a DMA transfer channel descriptor definition.
**     Settings    :
**          Component name                                 : DMAT_UART_OUT
**          DMA controller device                          : DMA1
**          Channel                                        : 
**            Channel select                               : Fixed
**              Channel                                    : DMA_Channel2
**              Interrupts                                 : Disabled
**              Allocate channel                           : yes
**          Trigger                                        : 
**            Trigger source type                          : Peripheral device
**              Trigger source                             : TPM2_CH0_DMA_Request
**              Periodic trigger                           : Disabled
**          Data source                                    : 
**            External object declaration                  : #include "Events.h"
**            Address                                      : (uint32_t)&MyOutputArray
**            Transfer size                                : 8-bit
**            Address offset                               : 1
**            Circular buffer                              : Buffer disabled
**          Data destination                               : 
**            External object declaration                  : 
**            Address                                      : (uint32_t)&UART0_D
**            Transfer size                                : 8-bit
**            Address offset                               : 0
**            Circular buffer                              : Buffer disabled
**          Data size                                      : 
**            External object declaration                  : 
**            Value                                        : OUTPUT_ARRAY_SIZE
**          Transfer control                               : Cycle-steal
**            Disable after transfer                       : yes
**            Asynchronous requests                        : Enabled
**            Channel linking                              : Disabled
**            After request complete                       : No action
**            After transfer complete                      : No action
**          Initialization                                 : 
**            Auto initialization                          : yes
**            Half complete                                : Disabled
**            Event mask                                   : 
**              OnComplete                                 : Disabled
**              OnError                                    : Disabled
**     Contents    :
**         Init                - LDD_TDeviceData* DMAT_UART_OUT_Init(LDD_TUserData *UserDataPtr);
**         Deinit              - void DMAT_UART_OUT_Deinit(LDD_TDeviceData *DeviceDataPtr);
**         AllocateChannel     - LDD_TError DMAT_UART_OUT_AllocateChannel(LDD_TDeviceData *DeviceDataPtr);
**         EnableChannel       - LDD_TError DMAT_UART_OUT_EnableChannel(LDD_TDeviceData *DeviceDataPtr);
**         DisableChannel      - LDD_TError DMAT_UART_OUT_DisableChannel(LDD_TDeviceData *DeviceDataPtr);
**         StartTransfer       - LDD_TError DMAT_UART_OUT_StartTransfer(LDD_TDeviceData *DeviceDataPtr);
**         GetChannelStatus    - LDD_DMA_TChannelStatus DMAT_UART_OUT_GetChannelStatus(LDD_TDeviceData...
**         SetSourceAddress    - LDD_TError DMAT_UART_OUT_SetSourceAddress(LDD_TDeviceData *DeviceDataPtr,...
**         SetByteCount        - LDD_TError DMAT_UART_OUT_SetByteCount(LDD_TDeviceData *DeviceDataPtr,...
**         SetDescriptorUpdate - LDD_TError DMAT_UART_OUT_SetDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr,...
**         GetDescriptorUpdate - LDD_TError DMAT_UART_OUT_GetDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE DMAT_UART_OUT. */

#include "DMAT_UART_OUT.h"
/* User external source object declaration */
#include "Events.h"

typedef struct {
  DMA1_TDeviceData *DMA_LDD_DeviceDataPtr; /* Pointer to the DMA_LDD component data structure */
  LDD_DMA_TTransferDescriptor *DescriptorPtr; /* Pointer to the component's transfer descriptor */
} DMAT_UART_OUT_TDeviceData;

/* {Default RTOS Adapter} Static object used for simulation of dynamic driver memory allocation */
static DMAT_UART_OUT_TDeviceData DeviceDataPtr__DEFAULT_RTOS_ALLOC;
/* {Default RTOS Adapter} Static object used for simulation of dynamic driver memory allocation */
static LDD_DMA_TTransferDescriptor DescriptorPtr__DEFAULT_RTOS_ALLOC;
/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_Init (component DMATransfer_LDD)
**
**     Description :
**         Initializes the DMATransfer component. Allocates memory for
**         the device data structure.
**         This method can be called only once. Before the second call
**         of Init() the Deinit() must be called first.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     Returns     :
**         ---             - Device data structure pointer.
** ===================================================================
*/
LDD_TDeviceData* DMAT_UART_OUT_Init(LDD_TUserData *UserDataPtr)
{
  DMAT_UART_OUT_TDeviceData *DeviceDataPtr; /* LDD device structure */
  LDD_DMA_TTransferDescriptor *DescriptorPtr; /* Transfer descriptor structure */

  /* Allocate LDD device structure */
  /* {Default RTOS Adapter} Driver memory allocation: Dynamic allocation is simulated by a pointer to the static object */
  DeviceDataPtr = &DeviceDataPtr__DEFAULT_RTOS_ALLOC;
  /* Allocate Transfer descriptor structure */
  /* {Default RTOS Adapter} Driver memory allocation: Dynamic allocation is simulated by a pointer to the static object */
  DescriptorPtr = &DescriptorPtr__DEFAULT_RTOS_ALLOC;
  DeviceDataPtr->DescriptorPtr = DescriptorPtr; /* Store pointer to the descriptor structure */
  /* Transfer descriptor initialization */
  DeviceDataPtr->DescriptorPtr->UserDataPtr = UserDataPtr; /* User device data structure pointer to be returned by the DMA_LDD component's ISR to the dynamic callback of this Descriptor */
  /* Source settings */
  DeviceDataPtr->DescriptorPtr->SourceAddress = (LDD_DMA_TAddress)(uint32_t)&MyOutputArray; /* Address of a DMA transfer source data */
  DeviceDataPtr->DescriptorPtr->SourceTransferSize = (LDD_DMA_TTransferSize)DMA_PDD_8_BIT; /* 8-bit source data transfer size. */
  DeviceDataPtr->DescriptorPtr->SourceModuloSize = (LDD_DMA_TModuloSize)DMA_PDD_CIRCULAR_BUFFER_DISABLED; /* Circular buffer size. */
  DeviceDataPtr->DescriptorPtr->SourceAddressIncrement = TRUE; /* Address incremented after each elemental read operation. */
  /* Destination settings */
  DeviceDataPtr->DescriptorPtr->DestinationAddress = (LDD_DMA_TAddress)(uint32_t)&UART0_D; /* Address of a DMA transfer destination data */
  DeviceDataPtr->DescriptorPtr->DestinationTransferSize = (LDD_DMA_TTransferSize)DMA_PDD_8_BIT; /* 8-bit destination data transfer size. */
  DeviceDataPtr->DescriptorPtr->DestinationModuloSize = (LDD_DMA_TModuloSize)DMA_PDD_CIRCULAR_BUFFER_DISABLED; /* Circular buffer size. */
  DeviceDataPtr->DescriptorPtr->DestinationAddressIncrement = FALSE; /* Address not incremented. */
  /* Byte count value */
  DeviceDataPtr->DescriptorPtr->ByteCount = (LDD_DMA_TByteCount)OUTPUT_ARRAY_SIZE; /* Size of data to be transferred. */
  /* Trigger settings */
  DeviceDataPtr->DescriptorPtr->TriggerType = LDD_DMA_HW_TRIGGER; /* External peripheral trigger is used */
  DeviceDataPtr->DescriptorPtr->TriggerSource = (LDD_DMA_TTriggerSource)0x22U; /* External peripheral trigger source number */
  DeviceDataPtr->DescriptorPtr->PeriodicTrigger = FALSE; /* Periodic trigger mode is not used */
  DeviceDataPtr->DescriptorPtr->ChannelAutoSelection = FALSE; /* DMA channel fixed value */
  DeviceDataPtr->DescriptorPtr->ChannelNumber = (LDD_DMA_TChannelNumber)0x02U; /* DMA channel number */
  DeviceDataPtr->DescriptorPtr->AsynchronousRequests = TRUE; /* DMA channel asynchronous requests enabled. */
  /* Inner and outer loop linking settings */
  DeviceDataPtr->DescriptorPtr->ChannelLinkingMode = LDD_DMA_LINKING_DISABLED; /* Channel linking disabled. */
  DeviceDataPtr->DescriptorPtr->InnerLoopLinkedChannel = 0x00U; /* Linked DMA channel number not used. */
  DeviceDataPtr->DescriptorPtr->OuterLoopLinkedChannel = 0x00U; /* Linked DMA channel number not used. */
  /* Transfer control settings */
  DeviceDataPtr->DescriptorPtr->TransferMode = LDD_DMA_CYCLE_STEAL_TRANSFERS; /* Cycle-steal transfers - one elementary read-write transfer per request. */
  DeviceDataPtr->DescriptorPtr->DisableAfterRequest = TRUE; /* Disable after request. */
  /* Interrupts and events settings */
  DeviceDataPtr->DescriptorPtr->Interrupts = FALSE; /* Interrupts are not requested. */
  DeviceDataPtr->DescriptorPtr->OnComplete = FALSE; /* Event disabled in initialization code. */
  DeviceDataPtr->DescriptorPtr->OnError = FALSE; /* Event disabled in initialization code. */
  DeviceDataPtr->DescriptorPtr->OnCompleteEventPtr = NULL; /* OnComplete event not enabled */
  DeviceDataPtr->DescriptorPtr->OnErrorEventPtr = NULL; /* OnError event not enabled */
  DeviceDataPtr->DescriptorPtr->ChannelEnabled = FALSE; /* Descriptor is not allocating nor using any channel. */
  if (PE_LDD_DeviceDataList[PE_LDD_COMPONENT_DMA1_ID] == NULL) {
    DeviceDataPtr->DMA_LDD_DeviceDataPtr = DMA1_Init(NULL);
  }
  else {
    DeviceDataPtr->DMA_LDD_DeviceDataPtr = PE_LDD_DeviceDataList[PE_LDD_COMPONENT_DMA1_ID];
  }
  /* Registration of the device structure */
  PE_LDD_RegisterDeviceStructure(PE_LDD_COMPONENT_DMAT_UART_OUT_ID,DeviceDataPtr);
  return ((LDD_TDeviceData *)DeviceDataPtr); /* Return pointer to the data data structure. */
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_Deinit (component DMATransfer_LDD)
**
**     Description :
**         Deinitializes the DMATransfer component.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/
void DMAT_UART_OUT_Deinit(LDD_TDeviceData *DeviceDataPtr)
{
  ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr = NULL;
  /* Unregistration of the device structure */
  PE_LDD_UnregisterDeviceStructure(PE_LDD_COMPONENT_DMAT_UART_OUT_ID);
  /* Deallocation of the Transfer descriptor structure */
  /* {Default RTOS Adapter} Driver memory deallocation: Dynamic allocation is simulated, no deallocation code is generated */
  /* Deallocation of the device structure */
  /* {Default RTOS Adapter} Driver memory deallocation: Dynamic allocation is simulated, no deallocation code is generated */
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_AllocateChannel (component DMATransfer_LDD)
**
**     Description :
**         The method allocates DMA channel for the DMA transfer. This
**         method must be called before DMA channel is initialized.
**         Otherwise ERR_NOTAVAIL error code is returned after call of
**         DMA_LDD channel methods.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any possible
**                           channel with desired features to be
**                           allocated.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_AllocateChannel(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_AllocateChannel((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_EnableChannel (component DMATransfer_LDD)
**
**     Description :
**         The method initializes and/or enables the DMA channel
**         allocated for the DMA transfer defined by the transfer
**         descriptor input parameter DescriptorPtr. First call of this
**         method on given DMA channel initializes it and enables HW
**         requests if Peripheral device or Always enabled trigger
**         source is selected in transfer descriptor Trigger source
**         type item. This method can be also used together with
**         Disable method to temporary switch On/Off the DMA channel HW
**         requests. In such case DMA channel registers are not
**         reinitialized again. New initialization of DMA channel can
**         be done via SetChannelDescriptorUpdate method which
**         reinitializes whole channel with new transfer descriptor.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Transfer descriptor data
**                           are inconsistent.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_EnableChannel(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_EnableChannel((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_DisableChannel (component DMATransfer_LDD)
**
**     Description :
**         The method disables the DMA channel allocated for the DMA
**         transfer. However, it is still possible to start transfer
**         explicitly as SW transfer requests via StartChannelTransfer
**         method.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_DisableChannel(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_DisableChannel((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_StartTransfer (component DMATransfer_LDD)
**
**     Description :
**         The method starts DMA transfer on the DMA channel allocated
**         for this transfer. This methods initiates explicit SW
**         transfer request.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_StartTransfer(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_StartChannelTransfer((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_GetChannelStatus (component DMATransfer_LDD)
**
**     Description :
**         The method gets a status of the DMA channel allocated for
**         the DMA transfer. This method is intended to perform fast
**         check of DMA channel transfer status and no validity or
**         consistency checks are performed. Possible values are
**         described in LDD_DMA_TChannelStatus type description.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - DMA channel status.
** ===================================================================
*/
LDD_DMA_TChannelStatus DMAT_UART_OUT_GetChannelStatus(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_GetChannelStatus((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_SetSourceAddress (component DMATransfer_LDD)
**
**     Description :
**         The method sets an data source address for to be transferred
**         by the DMA channel allocated for the DMA transfer. This
**         method can be used to update DMA transfer source address
**         when DMA channel is enabled. New source address is stored in
**         transfer descriptor and written to associated DMA channel
**         registers. The new source address can be optionally checked
**         for consistency with rest of the transfer descriptor data.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         Address         - Address of source data for the DMA
**                           channel allocated for this TCD.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected source address
**                           is inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_SetSourceAddress(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TAddress Address)
{
  return DMA1_SetChannelSourceAddress((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr, Address);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_SetByteCount (component DMATransfer_LDD)
**
**     Description :
**         The method sets a byte count (size of data) to be
**         transferred for the DMA transfer. This method can be used to
**         update DMA transfer byte count when DMA channel is enabled.
**         New transfer byte count is stored in transfer descriptor and
**         written to associated DMA channel registers. The new
**         transfer byte count can be optionally checked for
**         consistency with rest of the transfer descriptor data. If
**         nested operation is used, the method sets the minor (inner)
**         loop byte count.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         ByteCount       - Byte count (size of data) to
**                           be transferred by the DMA channel allocated
**                           for this TCD.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected byte count is
**                           inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_SetByteCount(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TByteCount ByteCount)
{
  return DMA1_SetChannelByteCount((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr, ByteCount);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_SetDescriptorUpdate (component DMATransfer_LDD)
**
**     Description :
**         Updates the DMA channel allocated for the component with new
**         Transfer descriptor. Address of Transfer descriptor used for
**         updated is passed as input parameter. This method can be
**         used to reinitialization of whole DMA channel. New Transfer
**         descriptor is tested for data consistency. The method could
**         be called only if the channel is disabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to transfer
**                           descriptor.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor or allocated channel is enabled.
**                           - ERR_PARAM_DATA - Transfer descriptor data
**                           are inconsistent.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_SetDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  return DMA1_SetChannelDescriptorUpdate((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_UART_OUT_GetDescriptorUpdate (component DMATransfer_LDD)
**
**     Description :
**         Get updated Transfer descriptor of the DMA channel allocated
**         for the component. The method updates components Transfer
**         descriptor structure and stores its address in the indirect
**         input parameter. The method can be called only if the DMA
**         channel is disabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorAddressPtr - Pointer
**                           to the address of DMA transfer descriptor
**                           structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor or allocated channel is enabled.
** ===================================================================
*/
LDD_TError DMAT_UART_OUT_GetDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptorPtr *DescriptorAddressPtr)
{
  LDD_TError Error;
  Error = DMA1_GetChannelDescriptorUpdate((LDD_TDeviceData *)(((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
  *DescriptorAddressPtr = ((DMAT_UART_OUT_TDeviceData *)DeviceDataPtr)->DescriptorPtr;
  return Error;
}

/* END DMAT_UART_OUT. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
