/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DMAT_Mem.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : DMATransfer_LDD
**     Version     : Component 01.099, Driver 01.07, CPU db: 3.00.000
**     Compiler    : IAR ARM C Compiler
**     Date/Time   : 2012-09-23, 22:47, # CodeGen: 119
**     Abstract    :
**          This embedded component implements
**          a DMA transfer channel descriptor definition.
**     Settings    :
**          Component name                                 : DMAT_Mem
**          DMA controller device                          : DMA1
**          Channel                                        : 
**            Channel select                               : Fixed
**              Channel                                    : DMA_Channel1
**              Interrupts                                 : Enabled
**              Allocate channel                           : yes
**          Trigger                                        : 
**            Trigger source type                          : Explicit software
**          Data source                                    : 
**            External object declaration                  : 
**            Address                                      : (uint32_t)&TPM2_C0V
**            Transfer size                                : 16-bit
**            Address offset                               : 0
**            Circular buffer                              : Buffer disabled
**          Data destination                               : 
**            External object declaration                  : 
**            Address                                      : (uint32_t)&MyStaticArray
**            Transfer size                                : 16-bit
**            Address offset                               : 2
**            Circular buffer                              : 128 Bytes
**          Data size                                      : 
**            External object declaration                  : 
**            Value                                        : SAMPLE_SIZE
**          Transfer control                               : Cycle-steal
**            Disable after transfer                       : no
**            Asynchronous requests                        : Enabled
**            Channel linking                              : Disabled
**            After request complete                       : No action
**            After transfer complete                      : No action
**          Initialization                                 : 
**            Auto initialization                          : yes
**            Half complete                                : Disabled
**            Event mask                                   : 
**              OnComplete                                 : Enabled
**              OnError                                    : Enabled
**     Contents    :
**         Init             - LDD_TDeviceData* DMAT_Mem_Init(LDD_TUserData *UserDataPtr);
**         Deinit           - void DMAT_Mem_Deinit(LDD_TDeviceData *DeviceDataPtr);
**         AllocateChannel  - LDD_TError DMAT_Mem_AllocateChannel(LDD_TDeviceData *DeviceDataPtr);
**         EnableChannel    - LDD_TError DMAT_Mem_EnableChannel(LDD_TDeviceData *DeviceDataPtr);
**         DisableChannel   - LDD_TError DMAT_Mem_DisableChannel(LDD_TDeviceData *DeviceDataPtr);
**         SetSourceAddress - LDD_TError DMAT_Mem_SetSourceAddress(LDD_TDeviceData *DeviceDataPtr,...
**         SetByteCount     - LDD_TError DMAT_Mem_SetByteCount(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __DMAT_Mem_H
#define __DMAT_Mem_H

/* MODULE DMAT_Mem. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "DMA1.h"
#include "PE_LDD.h"
#include "DMA_PDD.h"
#include "DMAMUX_PDD.h"

#include "Cpu.h"

/* Peripheral base address of a device allocated by the component. This constant can be used directly in PDD macros. */
#define DMAT_Mem_PRPH_BASE_ADDRESS  0x40008000U
  
/* Device data structure pointer used when auto initialization property is enabled. This constant can be passed as a first parameter to all component's methods. */
#define DMAT_Mem_DeviceData  ((LDD_TDeviceData *)PE_LDD_GetDeviceStructure(PE_LDD_COMPONENT_DMAT_Mem_ID))

/* Methods configuration constants - generated for all enabled component's methods */
#define DMAT_Mem_Init_METHOD_ENABLED
#define DMAT_Mem_Deinit_METHOD_ENABLED
#define DMAT_Mem_AllocateChannel_METHOD_ENABLED
#define DMAT_Mem_EnableChannel_METHOD_ENABLED
#define DMAT_Mem_DisableChannel_METHOD_ENABLED
#define DMAT_Mem_SetSourceAddress_METHOD_ENABLED
#define DMAT_Mem_SetByteCount_METHOD_ENABLED

/* Events configuration constants - generated for all enabled component's events */
#define DMAT_Mem_OnComplete_EVENT_ENABLED
#define DMAT_Mem_OnError_EVENT_ENABLED

/* Source circular buffer base address mask. Represents required 0-modulo-size mask of base source address when using circular buffer. */
#define DMAT_Mem_SOURCE_CIRCULAR_BUFFER_ADDRESS_MASK 0U
/* Destination circular buffer base address mask. Represents required 0-modulo-size mask of base destination address when using circular buffer. */
#define DMAT_Mem_DESTINATION_CIRCULAR_BUFFER_ADDRESS_MASK 127U

LDD_TDeviceData* DMAT_Mem_Init(LDD_TUserData *UserDataPtr);
/*
** ===================================================================
**     Method      :  DMAT_Mem_Init (component DMATransfer_LDD)
**
**     Description :
**         Initializes the DMATransfer component. Allocates memory for
**         the device data structure.
**         This method can be called only once. Before the second call
**         of Init() the Deinit() must be called first.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     Returns     :
**         ---             - Device data structure pointer.
** ===================================================================
*/

void DMAT_Mem_Deinit(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  DMAT_Mem_Deinit (component DMATransfer_LDD)
**
**     Description :
**         Deinitializes the DMATransfer component.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

LDD_TError DMAT_Mem_AllocateChannel(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  DMAT_Mem_AllocateChannel (component DMATransfer_LDD)
**
**     Description :
**         The method allocates DMA channel for the DMA transfer. This
**         method must be called before DMA channel is initialized.
**         Otherwise ERR_NOTAVAIL error code is returned after call of
**         DMA_LDD channel methods.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any possible
**                           channel with desired features to be
**                           allocated.
** ===================================================================
*/

LDD_TError DMAT_Mem_EnableChannel(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  DMAT_Mem_EnableChannel (component DMATransfer_LDD)
**
**     Description :
**         The method initializes and/or enables the DMA channel
**         allocated for the DMA transfer defined by the transfer
**         descriptor input parameter DescriptorPtr. First call of this
**         method on given DMA channel initializes it and enables HW
**         requests if Peripheral device or Always enabled trigger
**         source is selected in transfer descriptor Trigger source
**         type item. This method can be also used together with
**         Disable method to temporary switch On/Off the DMA channel HW
**         requests. In such case DMA channel registers are not
**         reinitialized again. New initialization of DMA channel can
**         be done via SetChannelDescriptorUpdate method which
**         reinitializes whole channel with new transfer descriptor.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Transfer descriptor data
**                           are inconsistent.
** ===================================================================
*/

LDD_TError DMAT_Mem_DisableChannel(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  DMAT_Mem_DisableChannel (component DMATransfer_LDD)
**
**     Description :
**         The method disables the DMA channel allocated for the DMA
**         transfer. However, it is still possible to start transfer
**         explicitly as SW transfer requests via StartChannelTransfer
**         method.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/

LDD_TError DMAT_Mem_SetSourceAddress(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TAddress Address);
/*
** ===================================================================
**     Method      :  DMAT_Mem_SetSourceAddress (component DMATransfer_LDD)
**
**     Description :
**         The method sets an data source address for to be transferred
**         by the DMA channel allocated for the DMA transfer. This
**         method can be used to update DMA transfer source address
**         when DMA channel is enabled. New source address is stored in
**         transfer descriptor and written to associated DMA channel
**         registers. The new source address can be optionally checked
**         for consistency with rest of the transfer descriptor data.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         Address         - Address of source data for the DMA
**                           channel allocated for this TCD.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected source address
**                           is inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/

LDD_TError DMAT_Mem_SetByteCount(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TByteCount ByteCount);
/*
** ===================================================================
**     Method      :  DMAT_Mem_SetByteCount (component DMATransfer_LDD)
**
**     Description :
**         The method sets a byte count (size of data) to be
**         transferred for the DMA transfer. This method can be used to
**         update DMA transfer byte count when DMA channel is enabled.
**         New transfer byte count is stored in transfer descriptor and
**         written to associated DMA channel registers. The new
**         transfer byte count can be optionally checked for
**         consistency with rest of the transfer descriptor data. If
**         nested operation is used, the method sets the minor (inner)
**         loop byte count.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         ByteCount       - Byte count (size of data) to
**                           be transferred by the DMA channel allocated
**                           for this TCD.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected byte count is
**                           inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/

/* END DMAT_Mem. */

#endif
/* ifndef __DMAT_Mem_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
