/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : LPTmr1.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : Init_LPTMR
**     Version     : Component 01.007, Driver 01.07, CPU db: 3.00.000
**     Compiler    : IAR ARM C Compiler
**     Date/Time   : 2012-09-23, 22:47, # CodeGen: 119
**     Abstract    :
**          This file implements the LPTMR (LPTMR0) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
**     Settings    :
**          Component name                                 : LPTmr1
**          Device                                         : LPTMR0
**          Settings                                       : 
**            Clock gate                                   : Enabled
**            Clock settings                               : 
**              Clock select                               : Internal Reference Clock
**              Prescale value/Glitch filter               : Prescaler/2; Glitch Filter not supported
**              Prescaler bypass                           : Bypassed
**            Compare value                                : 60000
**            Free running                                 : Disabled
**            Timer mode                                   : Timer Counter
**              Input clock frequency                      : 1 MHz
**              Period                                     : 60.0010 ms
**          Pins                                           : 
**            Input pin                                    : Disabled
**            Pin polarity                                 : Active High
**          Interrupts                                     : 
**            Interrupt                                    : INT_LPTimer
**            Interrupt request                            : Enabled
**            Interrupt priority                           : 0 (Highest)
**            ISR name                                     : LPTMR_IRQHandler
**            Timer interrupt                              : Disabled
**          Initialization                                 : 
**            Timer enable                                 : no
**            Call Init method                             : yes
**     Contents    :
**         Init - void LPTmr1_Init(void);
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE LPTmr1. */

#include "LPTmr1.h"
  /* Including shared modules, which are used in the whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Cpu.h"


/*
** ===================================================================
**     Method      :  LPTmr1_Init (component Init_LPTMR)
**
**     Description :
**         This method initializes registers of the LPTMR module
**         according to the Peripheral Initialization settings.
**         Call this method in user code to initialize the module. By
**         default, the method is called by PE automatically; see "Call
**         Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LPTmr1_Init(void)
{
  /* SIM_SCGC5: LPTMR=1 */
  SIM_SCGC5 |= SIM_SCGC5_LPTMR_MASK;                                                   
  /* LPTMR0_CSR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,TCF=0,TIE=0,TPS=0,TPP=0,TFC=0,TMS=0,TEN=0 */
  LPTMR0_CSR = 0x00U;                                                   
  /* LPTMR0_CMR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,COMPARE=0xEA60 */
  LPTMR0_CMR = LPTMR_CMR_COMPARE(0xEA60);                                                   
  /* LPTMR0_CSR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,TCF=1,TIE=0,TPS=0,TPP=0,TFC=0,TMS=0,TEN=0 */
  LPTMR0_CSR = LPTMR_CSR_TCF_MASK;                                                   
  /* LPTMR0_PSR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,PRESCALE=0,PBYP=1,PCS=0 */
  LPTMR0_PSR = LPTMR_PSR_PBYP_MASK;                                                   
  /* LPTMR0_CSR: TCF=0,TEN=0 */
  LPTMR0_CSR &= (uint32_t)~(uint32_t)((LPTMR_CSR_TCF_MASK | LPTMR_CSR_TEN_MASK));                                                   
}

/*
** ###################################################################
**
**  The interrupt service routine(s) must be implemented
**  by user in one of the following user modules.
**
**  If the "Generate ISR" option is enabled, Processor Expert generates
**  ISR templates in the CPU event module.
**
**  User modules:
**      ProcessorExpert.c
**      Events.c
**
** ###################################################################
PE_ISR(LPTMR_IRQHandler)
{
// NOTE: The routine should include actions to clear the appropriate
//       interrupt flags.
//
}
*/


/* END LPTmr1. */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
