/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : Blue_LED.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : BitIO_LDD
**     Version     : Component 01.021, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-10-01, 11:23, # CodeGen: 2
**     Abstract    :
**         The HAL BitIO component provides a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL BitIO API are simpler and more
**         portable to various microprocessors.
**     Settings    :
**          Component name                                 : Blue_LED
**          Pin for I/O                                    : ADC0_SE5b/PTD1/SPI0_SCK/TPM0_CH1
**          Pin signal                                     : 
**          Direction                                      : Output
**          Initialization                                 : 
**            Init. direction                              : Output
**            Init. value                                  : 1
**            Auto Initialization                          : yes
**          Safe mode                                      : no
**     Contents    :
**         Init   - LDD_TDeviceData* Blue_LED_Init(LDD_TUserData *UserDataPtr);
**         Deinit - void Blue_LED_Deinit(LDD_TDeviceData *DeviceDataPtr);
**         PutVal - void Blue_LED_PutVal(LDD_TDeviceData *DeviceDataPtr, bool Val);
**         ClrVal - void Blue_LED_ClrVal(LDD_TDeviceData *DeviceDataPtr);
**         SetVal - void Blue_LED_SetVal(LDD_TDeviceData *DeviceDataPtr);
**         NegVal - void Blue_LED_NegVal(LDD_TDeviceData *DeviceDataPtr);
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __Blue_LED_H
#define __Blue_LED_H

/* MODULE Blue_LED. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "IO_Map.h"
#include "GPIO_PDD.h"

#include "Cpu.h"



/* Peripheral base address of a device allocated by the component. This constant can be used directly in PDD macros. */
#define Blue_LED_PRPH_BASE_ADDRESS  0x400FF0C0U
  
/* Device data structure pointer used when auto initialization property is enabled. This constant can be passed as a first parameter to all component's methods. */
#define Blue_LED_DeviceData  ((LDD_TDeviceData *)PE_LDD_GetDeviceStructure(PE_LDD_COMPONENT_Blue_LED_ID))

/* Methods configuration constants - generated for all enabled component's methods */
#define Blue_LED_Init_METHOD_ENABLED
#define Blue_LED_Deinit_METHOD_ENABLED
#define Blue_LED_PutVal_METHOD_ENABLED
#define Blue_LED_ClrVal_METHOD_ENABLED
#define Blue_LED_SetVal_METHOD_ENABLED
#define Blue_LED_NegVal_METHOD_ENABLED

/* Definition of implementation constants */
#define Blue_LED_MODULE_BASE_ADDRESS FPTD_BASE_PTR /* Name of macro used as the base address */
#define Blue_LED_PORTCONTROL_BASE_ADDRESS PORTD_BASE_PTR /* Name of macro used as the base address */
#define Blue_LED_PORT_MASK 0x02U       /* Mask of the allocated pin from the port */



LDD_TDeviceData* Blue_LED_Init(LDD_TUserData *UserDataPtr);
/*
** ===================================================================
**     Method      :  Blue_LED_Init (component BitIO_LDD)
**
**     Description :
**         Initializes the device. Allocates memory for the device data
**         structure, allocates interrupt vectors and sets interrupt
**         priority, sets pin routing, sets timing, etc. If the "Enable
**         in init. code" is set to "yes" value then the device is also
**         enabled(see the description of the Enable() method). In this
**         case the Enable() method is not necessary and needn't to be
**         generated. 
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     Returns     :
**         ---             - Device data structure pointer.
** ===================================================================
*/

void Blue_LED_Deinit(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  Blue_LED_Deinit (component BitIO_LDD)
**
**     Description :
**          Deinitializes the device. Switches off the device, frees
**         the device data structure memory, interrupts vectors, etc.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

void Blue_LED_PutVal(LDD_TDeviceData *DeviceDataPtr, bool Val);
/*
** ===================================================================
**     Method      :  Blue_LED_PutVal (component BitIO_LDD)
**
**     Description :
**         The specified output value is set. If the direction is
**         [input], the component saves the value to a memory or a
**         register and this value will be written to the pin after
**         switching to the output mode (using [SetDir(TRUE)]; see
**         <Safe mode> property for limitations). If the direction is
**         [output], it writes the value to the pin. (Method is
**         available only if the direction = _[output]_ or
**         _[input/output]_).
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         Val             - Output value. Possible values:
**                           <false> - logical "0" (Low level)
**                           <true> - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/

void Blue_LED_ClrVal(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  Blue_LED_ClrVal (component BitIO_LDD)
**
**     Description :
**         Clears (set to zero) the output value. It is equivalent to
**         the [PutVal(FALSE)]. This method is available only if the
**         direction = _[output]_ or _[input/output]_.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Pointer to device data
**                           structure returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

void Blue_LED_SetVal(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  Blue_LED_SetVal (component BitIO_LDD)
**
**     Description :
**         Sets (to one) the output value. It is equivalent to the
**         [PutVal(TRUE)]. This method is available only if the
**         direction = _[output]_ or _[input/output]_.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Pointer to device data
**                           structure returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

void Blue_LED_NegVal(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  Blue_LED_NegVal (component BitIO_LDD)
**
**     Description :
**         Negates (inverts) the output value. It is equivalent to the
**         [PutVal(!GetVal())]. This method is available only if the
**         direction = _[output]_ or _[input/output]_.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Pointer to device data
**                           structure returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

/* END Blue_LED. */

#endif
/* ifndef __Blue_LED_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
