/** ###################################################################
**     Filename    : ProcessorExpert.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Version     : Driver 01.01
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-08-08, 16:59, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/* MODULE ProcessorExpert */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "Blue_LED.h"
#include "Green_LED.h"
#include "Red_LED.h"
#include "CsIO1.h"
#include "IO1.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#include "stdio.h"

/* Global Variables */
char InpData[10];
volatile bool DataReceivedFlg = FALSE;

int main(void)
{
  /* Write your local variable definition here */
  char temp_char;
  LDD_TError Error;

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  
  Blue_LED_ClrVal(Blue_LED_DeviceData);
  Green_LED_SetVal(Green_LED_DeviceData);
  Red_LED_SetVal(Red_LED_DeviceData);
  
  printf("Hello World!!!\n\n");
  printf("Enter any character to change LED color...\n");
 
  while(1)
  {
      
#ifndef CW
	  InpData[0] = getchar();
      // If not using CodeWarrior
      printf("%c",InpData[0]);
#else
      // If we are using CodeWarrior, call local function to receive and send 
      // characters from and to the terminal due to an issue with the ConsoleIO component 
      // and CodeWarrior
      
      // Receive character
      InpData[0] = uart_getchar(TERM_PORT_NUM);
        
      // Echo character
      uart_putchar(TERM_PORT_NUM, InpData[0]);  //Send the received character to terminal
#endif
      Blue_LED_SetVal(Blue_LED_DeviceData);
      Green_LED_ClrVal(Green_LED_DeviceData);
      Red_LED_SetVal(Red_LED_DeviceData);
		 
      
#ifndef CW
      InpData[0] = getchar();
      // If not using CodeWarrior
      printf("%c",InpData[0]);
#else
      // If we are using CodeWarrior, call local function to receive and send 
      // characters from and to the terminal due to an issue with the ConsoleIO component 
      // and CodeWarrior
            
      // Receive character
      InpData[0] = uart_getchar(TERM_PORT_NUM);
              
      // Echo character
      uart_putchar(TERM_PORT_NUM, InpData[0]);  //Send the received character to terminal
#endif
      UART0_D = InpData[0];
      Blue_LED_SetVal(Blue_LED_DeviceData);
      Green_LED_SetVal(Green_LED_DeviceData);
      Red_LED_ClrVal(Red_LED_DeviceData);
		  
      
#ifndef CW
      InpData[0] = getchar();
      // If not using CodeWarrior
      printf("%c",InpData[0]);
#else
      // If we are using CodeWarrior, call local function to receive and send 
      // characters from and to the terminal due to an issue with the ConsoleIO component 
      // and CodeWarrior
           
      // Receive character
      InpData[0] = uart_getchar(TERM_PORT_NUM);
             
      // Echo character
      uart_putchar(TERM_PORT_NUM, InpData[0]);  //Send the received character to terminal
#endif
      UART0_D = InpData[0];
      Blue_LED_ClrVal(Blue_LED_DeviceData);
      Green_LED_ClrVal(Green_LED_DeviceData);
      Red_LED_SetVal(Red_LED_DeviceData);
		 
      
#ifndef CW
      InpData[0] = getchar();
      // If not using CodeWarrior
      printf("%c",InpData[0]);
#else
      // If we are using CodeWarrior, call local function to receive and send 
      // characters from and to the terminal due to an issue with the ConsoleIO component 
      // and CodeWarrior
            
      // Receive character
      InpData[0] = uart_getchar(TERM_PORT_NUM);
              
      // Echo character
      uart_putchar(TERM_PORT_NUM, InpData[0]);  //Send the received character to terminal
#endif
      UART0_D = InpData[0];
      Blue_LED_SetVal(Blue_LED_DeviceData);
      Green_LED_ClrVal(Green_LED_DeviceData);
      Red_LED_ClrVal(Red_LED_DeviceData);
		 
      
#ifndef CW
      InpData[0] = getchar();
      // If not using CodeWarrior
      printf("%c",InpData[0]);
#else
      // If we are using CodeWarrior, call local function to receive and send 
      // characters from and to the terminal due to an issue with the ConsoleIO component 
      // and CodeWarrior
            
      // Receive character
      InpData[0] = uart_getchar(TERM_PORT_NUM);
              
      // Echo character
      uart_putchar(TERM_PORT_NUM, InpData[0]);  //Send the received character to terminal
#endif
      UART0_D = InpData[0];
      Blue_LED_ClrVal(Blue_LED_DeviceData);
      Green_LED_SetVal(Green_LED_DeviceData);
      Red_LED_ClrVal(Red_LED_DeviceData);
		 
      
#ifndef CW
      InpData[0] = getchar();
      // If not using CodeWarrior
      printf("%c",InpData[0]);
#else
      // If we are using CodeWarrior, call local function to receive and send 
      // characters from and to the terminal due to an issue with the ConsoleIO component 
      // and CodeWarrior
            
      // Receive character
      InpData[0] = uart_getchar(TERM_PORT_NUM);
              
      // Echo character
      uart_putchar(TERM_PORT_NUM, InpData[0]);  //Send the received character to terminal      
#endif
      UART0_D = InpData[0];
      Blue_LED_ClrVal(Blue_LED_DeviceData);
      Green_LED_SetVal(Green_LED_DeviceData);
      Red_LED_SetVal(Red_LED_DeviceData);
		 
  }
  

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
  return 0;
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END ProcessorExpert */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.02]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
